% El método QR para hallar todos los autovalores (y autovectores)
% de una matriz simétrica [definida positiva] y con autovalores simples.

% Autovalores: 8, 6, 4, 2
A = [5,0,-2,1; 0,5,-1,2; -2,-1,5,0; 1,2,0,5];

% El método consiste en hacer la descomposición QR de la matriz 
% redefinir la matriz como R*Q y repetir el procedimiento.
% A= Q*R, A:= R*Q=Q^-1*A*Q ...

N = 15;
n = size(A,1);
Qv = eye(n);
for k= 1:N
    [Q,R] = qr(A);
    A = R*Q;
    Qv = Qv*Q;
end
disp('Aproximación de los autovalores')
disp(diag(A))
disp('Aproximación de los autovectores')
Qv


