% La convergencia de punto fijo se puede acelerar con la 
% extrapolación de Aitken.
% x_{n+1} = x_n - ( g(x_n) -x_n )^2/ ( g(g(x_n)) - 2g(x_n) +x_n )
% Esto "acelera" la iteración x_{n+1} = g(x_n)

g = @(x) x-1/2*(x^2-2);
%g = @(x) (x+2/x)/2;

format long
N = 2;
x = 1;
xa = 1;
for k=1:N
    x = g(x);
    xa = xa -( g(xa) -xa )^2/(g(g(xa)) - 2*g(xa) +xa);
end
err = x-sqrt(2);
disp(['Error absoluto ' num2str(err)])
err = xa-sqrt(2);
disp(['Error absoluto (acelerado) ' num2str(err)])